package com.joaquim.calvo.serloc.serlocapi.application.service.persistance;

import com.joaquim.calvo.serloc.serlocapi.domain.service.Service;
import com.joaquim.calvo.serloc.serlocapi.domain.service.request.GetServicesRequest;

import java.util.List;

public interface SerlocServiceRepository {

    /**
     * Obtain all the available services applying the filter.
     * @return all the available services.
     * TODO: incorporate the filter.
     */
    List<Service> getAvailableServices(GetServicesRequest request);

    /**
     * Get the user services defined by a specific user.
     * @param email the user email.
     * @return the encountered services.
     */
    List<Service> getUserServices(String email);

    /**
     * Persist a new service definition.
     * @param newService new service definition.
     * @return the persisted new service definition.
     */
    Service saveNewService(Service newService);

    /**
     * Get a new autogenerated id for a new service definition.
     * @return the new generate id.
     */
    Integer getNewId();
}
