package com.joaquim.calvo.serloc.serlocapi.application.user.persistance;

import com.joaquim.calvo.serloc.serlocapi.domain.user.User;

import java.util.Optional;

public interface UserRepository {

    /**
     * Search user by user id.
     * @param userId user id.
     * @return encountred user.
     */
    User findUserById(Integer userId);

    /**
     * Search user by email.
     * @param email user emial to search.
     * @return encountred user.
     */
    Optional<User> findUserByEmail(String email);

    /**
     * Persist a new user definition.
     * @param newUser new user definition.
     */
    void persistNewUser(User newUser);
}
