package com.joaquim.calvo.serloc.serlocapi.domain.chat;

import com.joaquim.calvo.serloc.serlocapi.domain.user.User;

import javax.persistence.*;

@Entity
@Table(name = "message")
public class Message {

    @Id
    private int id;

    @Basic
    private String message;

    @Transient
    private User sender;

    @Transient
    private User receiver;

    @Transient
    private MessageStatus status;

    /**
     * Default constructor
     * for message.
     */
    private Message() {

    }

    /**
     * Base Message constructor
     * with the base and required fields.
     * @param id id
     * @param message message.
     * @param sender user which sends the message.
     * @param receiver user which recieves the message.
     */
    public Message(
            final int id,
            final String message,
            final User sender,
            final User receiver) {

        this.id = id;
        this.message = message;
        this.sender = sender;
        this.receiver = receiver;
        this.status = MessageStatus.CREATED;
    }

    public int getId() {
        return id;
    }

    public String getMessage() {
        return message;
    }

    public User getSender() {
        return sender;
    }

    public User getReceiver() {
        return receiver;
    }

    public MessageStatus getStatus() {
        return status;
    }

    public void setStatus(MessageStatus status) {
        this.status = status;
    }
}
