package com.joaquim.calvo.serloc.serlocapi.domain.service;

import javax.persistence.Basic;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;

@Entity
@Table(name = "service_type")
public class ServiceType {

    @Id
    private int id;

    @Basic
    private String name;

    @Basic
    private String description;

    /**
     * Default constructor.
     */
    private ServiceType() {

    }

    /**
     * Base serviceType construction
     * with basic and required fields.
     * @param id id
     * @param name service type name.
     * @param description service type descrption
     */
    public ServiceType(
            final Integer id,
            final String name,
            final String description) {
        this.id = id;
        this.name = name;
        this.description = description;
    }

    public int getId() {
        return id;
    }

    public String getName() {
        return name;
    }

    public String getDescription() {
        return description;
    }
}
