package com.joaquim.calvo.serloc.serlocapi.domain.service.service;

import com.joaquim.calvo.serloc.serlocapi.domain.service.Service;
import com.joaquim.calvo.serloc.serlocapi.domain.service.request.CreateNewServiceRequest;
import com.joaquim.calvo.serloc.serlocapi.domain.service.request.GetServicesRequest;

import java.util.List;

public interface SerlocService {

    /**
     * Obtain all the available services appying the apropiate filters.
     * @return the available services.
     */
    List<Service> getAvailableServices(GetServicesRequest request);

    /**
     * Obtain the services defined by a specific user.
     * @param userEmail user email.
     * @return the encountered services defined by the user.
     */
    List<Service> getServicesForUserByEmail(String userEmail);

    /**
     * Function which creates and persist a new service.
     * @param request request with all the service fields.
     * @return the new service identification.
     */
    Service createNewService(CreateNewServiceRequest request);
}
