package com.joaquim.calvo.serloc.serlocapi.domain.user.service;

import com.joaquim.calvo.serloc.serlocapi.domain.user.User;
import com.joaquim.calvo.serloc.serlocapi.domain.user.request.CreateNewUserRequest;

import java.util.Optional;

public interface UserService {

    /**
     * Get user information with the provided user id.
     * @param userId user id.
     * @return encountred user information.
     */
    User getUserInformation(Integer userId);

    /**
     * Create new user with the information provided by the request.
     * @param request request.
     */
    void createNewUser(CreateNewUserRequest request);

    /**
     * Obtain user by email.
     * @param email the user email.
     * @return the possible encountered user.
     */
    Optional<User> getUserByEmail(String email);
}
