package com.joaquim.calvo.serloc.serlocapi.infraestructure.persistance.repository.service;

import com.joaquim.calvo.serloc.serlocapi.application.service.persistance.ServiceTypeRepository;
import com.joaquim.calvo.serloc.serlocapi.domain.service.ServiceType;
import com.joaquim.calvo.serloc.serlocapi.infraestructure.persistance.repository.SerlocServiceRepository;

import javax.inject.Named;
import javax.persistence.TypedQuery;

@Named
public class HibernateServiceTypeRepository extends SerlocServiceRepository
    implements ServiceTypeRepository {

    @Override
    public ServiceType getServiceTypeById(Integer serviceTypeId) {
        final TypedQuery<ServiceType> query = getSerlocPersistence().createQuery("" +
                " FROM ServiceType serviceType " +
                " WHERE serviceType.id = :serviceTypeId", ServiceType.class)
                .setParameter("serviceTypeId", serviceTypeId);

        return query.getSingleResult();
    }
}
