package com.joaquim.calvo.serloc.serlocapi.infraestructure.persistance.repository.user;

import com.joaquim.calvo.serloc.serlocapi.application.user.persistance.UserRepository;
import com.joaquim.calvo.serloc.serlocapi.domain.user.User;
import com.joaquim.calvo.serloc.serlocapi.infraestructure.persistance.repository.SerlocServiceRepository;

import javax.inject.Named;
import javax.persistence.Query;
import javax.persistence.TypedQuery;
import java.util.Optional;

@Named
public class HibernateUserRepository
        extends SerlocServiceRepository
        implements UserRepository {


    @Override
    public User findUserById(Integer userId) {

        final Query query = getSerlocPersistence().createQuery("FROM User user " +
                " WHERE user.id = :userId")
        .setParameter("userId", userId);

        return (User) query.getSingleResult();

    }

    @Override
    public Optional<User> findUserByEmail(String email) {
        TypedQuery<User> findUserByEmailQuery = getSerlocPersistence().createQuery(
                "FROM User user WHERE user.email = :email", User.class)
                .setParameter("email", email);

        return Optional.ofNullable(findUserByEmailQuery.getSingleResult());
    }

    @Override
    public void persistNewUser(User newUser) {
        getSerlocPersistence().persist(newUser);
    }
}
