package com.joaquim.calvo.serloc.serlocapi.infraestructure.security.service;

import com.joaquim.calvo.serloc.serlocapi.application.user.persistance.UserRepository;
import org.springframework.security.core.userdetails.UserDetails;
import org.springframework.security.core.userdetails.UserDetailsService;
import org.springframework.security.core.userdetails.UsernameNotFoundException;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.inject.Inject;

/**
 * User details service which allows to spring security to
 * get the information about users.
 */
@Service
public class SerlocUserDetailsService implements UserDetailsService {

    @Inject
    private UserRepository userRepository;

    @Override
    @Transactional(readOnly = true)
    public UserDetails loadUserByUsername(String username) throws UsernameNotFoundException {
        return userRepository.findUserByEmail(username)
                .orElseThrow(() -> {
                    return new UsernameNotFoundException(username);
                });
    }
}
