package com.joaquim.calvo.serloc.serlocapi.infraestructure.web.controller.chat;

import com.joaquim.calvo.serloc.serlocapi.domain.chat.Message;
import com.joaquim.calvo.serloc.serlocapi.domain.chat.service.ChatService;
import com.joaquim.calvo.serloc.serlocapi.domain.user.service.UserService;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import javax.inject.Inject;
import java.security.Principal;
import java.util.List;

@RestController
@RequestMapping("/secured/chat")
public class ChatRestController {

    @Inject
    private ChatService chatService;

    @Inject
    private UserService userService;

    @RequestMapping( value = "", method = RequestMethod.GET)
    public List<Message> getMessagesForUser(final Principal principal) {
        return chatService.obtainAllUserMessages(principal.getName());
    }
}
