package com.joaquim.calvo.serloc.serlocapi.infraestructure.web.controller.service;

import com.joaquim.calvo.serloc.serlocapi.domain.service.request.CreateNewServiceRequest;
import com.joaquim.calvo.serloc.serlocapi.domain.service.response.CreatedNewServiceResponse;
import com.joaquim.calvo.serloc.serlocapi.domain.service.service.SerlocService;
import com.joaquim.calvo.serloc.serlocapi.domain.service.request.GetServicesRequest;
import com.joaquim.calvo.serloc.serlocapi.domain.service.response.AvailableServicesResponse;
import org.springframework.web.bind.annotation.*;

import javax.inject.Inject;
import java.security.Principal;

@RestController
@RequestMapping("/secured/service")
public class ServiceRestController {

    @Inject
    private SerlocService serlocServiceService;

    @RequestMapping(value = "" , method = RequestMethod.GET)
    public AvailableServicesResponse getAvailableServices(GetServicesRequest request) {
         return new AvailableServicesResponse(serlocServiceService.getAvailableServices(request));
    }

    @RequestMapping(value = "", method = RequestMethod.POST)
    public void createNewService(@RequestBody CreateNewServiceRequest request,
                                 Principal authenticatedUser) {

        request.setServiceProviderEmail(authenticatedUser.getName());
        serlocServiceService.createNewService(request);
    }
}
