package com.joaquim.calvo.serloc.serlocapi.infraestructure.web.controller.user;

import com.joaquim.calvo.serloc.serlocapi.domain.service.response.UserAvailableServicesResponse;
import com.joaquim.calvo.serloc.serlocapi.domain.service.service.SerlocService;
import com.joaquim.calvo.serloc.serlocapi.domain.user.User;
import com.joaquim.calvo.serloc.serlocapi.domain.user.response.UserDetailsResponse;
import com.joaquim.calvo.serloc.serlocapi.domain.user.service.UserService;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import javax.inject.Inject;
import java.security.Principal;

@RestController
@RequestMapping("/secured/user")
public class UserRestController {

    @Inject
    private UserService userService;

    @Inject
    private SerlocService serlocService;

    @RequestMapping(value = "/{id}", method = RequestMethod.GET)
    public User getUserInformation(
            Principal principal,
            @PathVariable("id") Integer userId
    ) {
        return userService.getUserInformation(userId);
    }

    @RequestMapping(value = "/services", method = RequestMethod.GET)
    public UserAvailableServicesResponse getUserDefinedServices(Principal principal) {
        return new UserAvailableServicesResponse(serlocService.getServicesForUserByEmail(principal.getName()));
    }

    @RequestMapping(value = "/userDetails", method = RequestMethod.GET)
    public UserDetailsResponse getUserDetails(final Principal principal) {
        final User user = userService.getUserByEmail(principal.getName()).get();
        return new UserDetailsResponse(user);
    }
}
